package svghexajongg;

/**
 *
 * @author uja
 * Leckerchen: SVG-Grafik, Generierung lösbarer Bretter
 * 01.12.2011
 * 
 *
 */
import java.util.Random;
import common.liste;

public class game
{ static final int maxx=40,maxy=32,maxz=8,cmax=144,fmax=36;
  static int xmax=maxx,ymax=maxy,zmax=maxz;
  Thread thread0,thread1,thread2; // ohne geht's wohl nicht
  boolean gestoppt=false;

  sprite stein[]=new sprite[cmax];
  int rest=144,zeit=1000;
  String messi="";
  boolean show_zugliste=true;
  int gewaehlt=-1;
  int[][][] f =new int[maxx][maxy][maxz];     // Brett, Inhalt: Stein-Id oder -1
  liste sliste=new liste(cmax);   // undo/Restart-Steinliste
  liste zliste=new liste(2*cmax); // Zug/Hiliteliste
  liste lliste=new liste(cmax); // Lösung
  int tliste[]=new int[cmax];  // Pointer nach Farben sortiert
  int pliste[]=new int[cmax];  // Pointer nach Prioritäten sortiert
  int v[]=new int[cmax]; // Vektorenliste zum allgemeinen Gebrauch
  Random r=new Random();

  public game() { for (int i=0; i<cmax; i++) stein[i]=new sprite(i); }

  // aktuelle Brettdimensionen:
  public int get_xmax() { return xmax; }
  public int get_ymax() { return ymax; }
  public int get_zmax() { return zmax; }

  // Level aud Textfile aufbauen: Steine zeilenweise, x,y,z kommagetrennt:
  public void prepare_level(String[] raw)
  { int i,j,k;
    String s1[]=new String[3];
    k=0;
    for (i=0; i<cmax; i++)
    { s1=raw[i].split(",");
      stein[i].set_koo(Integer.parseInt(s1[0]),Integer.parseInt(s1[1]),Integer.parseInt(s1[2]));
      stein[i].set_typ(k);
      if (i%4==3) k++;
      f[stein[i].ix][stein[i].iy][stein[i].iz]=i;
      stein[i].on();
    }
    sync_feld();
    // aktuelle Brettdimensionen berechnen:
    xmax=0; ymax=0; zmax=0;
    for (i=0; i<cmax; i++)
    { if (xmax<stein[i].ix) xmax=stein[i].ix;
      if (ymax<stein[i].iy) ymax=stein[i].iy;
      if (zmax<stein[i].iz) zmax=stein[i].iz;
    }
    xmax=xmax+4;
    ymax=ymax+4;
    zmax++;
    for (i=0; i<cmax; i++) stein[i].set_maxkoo(xmax,ymax,zmax);
    sort_prio();
    Main.resize(); // zeichnet den ganzen Kladderadatsch mit den aktuellen Werten neu
  }

  // Spiel initialisieren:
  public void neu() { thread0=null; lliste.leeren(); for (int i=0; i<cmax; i++) stein[i].on(); mischen(); restart(); }
  public void drehen() 
  { for (int i=0; i<cmax; i++) stein[i].set_koo(xmax-stein[i].ix-1,ymax-stein[i].iy-1,stein[i].iz); sort_prio();
    sync_feld();
  }

  public void restart()
  { if (thread0!=null) thread0=null;
    gewaehlt=-1; rest=cmax; zliste.leeren(); sliste.leeren(); steinsort();
    for (int i=0; i<cmax; i++) stein[i].on();
    Main.set_undobutt(false);
    messi="";
    zeit=0;
    gestoppt=false;
    if (thread2==null) start_timer();    
  }

  public void klick(int nr)
  { if (thread0!=null) thread0=null;
    if (thread1!=null) thread1=null;
    if (thread2!=null) gestoppt=true;

    if (nr>=0) if (ist_frei(nr))
    { zliste.leeren();
      if (gewaehlt<0) { gewaehlt=nr;  zliste.add_liste(nr); Main.play(0); }
      else
      { if ((nr!=gewaehlt) && (stein[nr].get_typ()==stein[gewaehlt].get_typ()))
        { Main.play(1);
          sliste.add_liste(nr); sliste.add_liste(gewaehlt);
          stein[nr].off(); stein[gewaehlt].off();
          gewaehlt=-1;
          rest=rest-2;
          if (sliste.get_size()<3) Main.set_undobutt(true); // ab 2 Items einschalten
          if ((rest>0) && (!is_move())) Main.popup(Main.langdef.get("OUTAMOVES"));
          else if (rest==0) Main.play(3);
        }
        else { gewaehlt=nr; zliste.add_liste(nr); Main.play(0); }
      }
    }
    if (rest>0) gestoppt=false;
  }

  public void undo()
  { int n0=sliste.get_size();
    if (n0>1)
    { Main.play(2);
      int n1=sliste.get_element(n0-1),n2=sliste.get_element(n0-2);
      stein[n1].on(); stein[n2].on(); rest=rest+2;
      sliste.shorten(n0-2);
    }
    if (sliste.get_size()<2) Main.set_undobutt(false);
  }

  public void mach_zugliste() // wie der Name schon sagt...
  { int i,j;
    zliste.leeren();
    for (i=0; i<cmax-1; i++) if (stein[i].is_aktiv()) if (ist_frei(i))
     for (j=i+1; j<cmax; j++) if (stein[j].typ==stein[i].typ) if (stein[j].is_aktiv())
      if (ist_frei(j)) { zliste.add2(i); zliste.add2(j); }
  }

  // interner nützlicher Kleinkram
  // ----------------------------------------------------------------------------------------------------------------------------------------------
  void sync_feld()
  { int i,j,k;
    for (k=0; k<maxz; k++) for (j=0; j<maxy; j++) for (i=0; i<maxx; i++) f[i][j][k]=-1;
    for (i=0; i<cmax; i++) f[stein[i].ix][stein[i].iy][stein[i].iz]=i;
  }

  boolean is_move() { show_zugliste=false; mach_zugliste(); boolean ret=(zliste.get_size()>0); zliste.leeren(); show_zugliste=true; return ret; }
  void sort_prio() { int[]v0=new int[cmax]; for (int i=0; i<cmax; i++) v0[i]=stein[i].get_prio(); pliste=shelsort(v0); } // korrekte Darstellung der Steine
  void steinsort() { int[]v0=new int[cmax]; for (int i=0; i<cmax; i++) v0[i]=stein[i].get_typ();  tliste=shelsort(v0); } // geordnete Steinübersicht
  int[] shelsort(int[] wert)
  { int i,k;
    int[] vec=new int[cmax];
    boolean getauscht;
    for (i=0; i<cmax; i++)  vec[i] = i;
    int delta=(int) Math.floor((double)(cmax)/2);
    while (delta>0)
    { getauscht=false;
      for (i=0; i<(cmax-delta); i++)
      { if (wert[vec[i]]>wert[vec[i+delta]])
        { k=vec[i]; vec[i]=vec[i+delta]; vec[i+delta]=k;
          getauscht=true;
        }
      }
      if (!getauscht) delta=(int) Math.floor((double)(delta)/2);
    }
    return vec;
  }

  // wenn mindestens 2 freie Steine, aktive Steine mischen zur Generierung lösbarer Bretter und Weiterkommen bei Zufallsbrettern:
  boolean mischen()
  { int i,j,k,ptr=0,fptr=0;
    zliste.leeren();
    for (i=0; i<cmax; i++) if (stein[i].is_aktiv())
    { v[ptr]=stein[i].get_typ(); ptr++;
      if (ist_frei(i)) fptr++;
    }
    if (fptr>1) while (zliste.get_size()<1)
    { for (i=0; i<ptr; i++) { k=r.nextInt(ptr)%ptr; j=v[i]; v[i]=v[k]; v[k]=j; }
      ptr=0; for (i=0; i<cmax; i++) if (stein[i].is_aktiv()) { stein[i].set_typ(v[ptr]); ptr++; }
      mach_zugliste();
    }
    steinsort();
    zliste.leeren();
    return (fptr>1);
  }

  // Check, ob Stein zugänglich ist, Steintyp Hexagon Size 4x2, senkrecht orientiert:
  boolean ist_frei(int nr)
  { int i,j,ix,iy,iz;
    boolean rechtso=true,rechtsu=true,linkso=true,linksu=true,oben=true,unten=true,frei=true;
    ix=stein[nr].get_ix(); iy=stein[nr].get_iy(); iz=stein[nr].get_iz();
    // obere Ebene checken: y=y1: Stein x=-3 bis +3, y=-1, y+1: x=-2 bis +2
    if (iz<zmax-1)
    { j=iy; for (i=ix-3; i<=ix+3; i++) if ((i>=0) && (i<xmax)) if (f[i][j][iz+1]>=0) if (stein[f[i][j][iz+1]].is_aktiv()) frei=false;
      j=iy-1; if (j>=0) for (i=ix-2; i<=ix+2; i++) if ((i>=0) && (i<xmax)) if (f[i][j][iz+1]>=0) if (stein[f[i][j][iz+1]].is_aktiv()) frei=false;
      j=iy+1; if (j<ymax) for (i=ix-2; i<=ix+2; i++) if ((i>=0) && (i<xmax)) if (f[i][j][iz+1]>=0) if (stein[f[i][j][iz+1]].is_aktiv()) frei=false;
    }
    // rechts oder links frei:
    if (frei) 
    { i=iy-2; if (i>=0) if (f[ix][i][iz]>=0) if (stein[f[ix][i][iz]].is_aktiv()) oben=false;
      i=iy+2; if (i<ymax) if (f[ix][i][iz]>=0) if (stein[f[ix][i][iz]].is_aktiv()) unten=false;
      i=ix+3;
      if (i<xmax)
      { j=iy-1; if (j>=0) if (f[i][j][iz]>=0) if (stein[f[i][j][iz]].is_aktiv()) rechtso=false;
        j=iy+1; if (j<ymax) if (f[i][j][iz]>=0) if (stein[f[i][j][iz]].is_aktiv()) rechtsu=false;
      }
      i=ix-3;
      if (i>=0)
      { j=iy-1; if (j>=0) if (f[i][j][iz]>=0) if (stein[f[i][j][iz]].is_aktiv()) linkso=false;
        j=iy+1; if (j<ymax) if (f[i][j][iz]>=0) if (stein[f[i][j][iz]].is_aktiv()) linksu=false;
      }
    }
    // System.out.println("x:"+ix+", y:"+iy+", z:"+iz+" obenfrei:"+frei+"   o"+oben+" u"+unten+" ro"+rechtso+ " ru"+rechtsu+" lo"+linkso+" lu"+linksu);
    if (frei) frei=((rechtso && rechtsu) || (linkso && linksu) || (oben && rechtso) || (oben && linkso) || (unten && rechtsu) || (unten && linksu));
    return frei;
  }
  
// ----------------------------------------------------------------------------------------------------------------------------------
// Generierung lösbarer Bretter, Einstieg über mach_loesbar(), umgeschrieben auf Thread, da: rekursiv geht's schief, sogar mit while ausserhalb Netbeans
// ----------------------------------------------------------------------------------------------------------------------------------
  public void mach_loesbar()
  { thread1=new Thread()
    { int k=0,cnt=0,weitermit=0;
      @Override public void run()
      { while ((this!=null) && (weitermit>=0))
        { switch (weitermit)
          { case 0: cnt++; neu(); lliste.leeren(); if (cnt<100) weitermit=1; else weitermit=-99; break;
            case 1: k = versuch(); if (k<1) weitermit=-1; else if (mischen()) weitermit=1; else weitermit=0; break;
          }
          yield();
        }
        if (weitermit==-99) Main.popup("Warning! Pattern too complicated!"); else restart();
      }
    };
    thread1.start();
   }
    
  int versuch()
  { int i,k,n1,n2,cnt;
    mach_zugliste();
    k=zliste.get_size();
    while (k>1)
    { k=k/2;
      i=r.nextInt(k)%k;
      n1=zliste.get_element(2*i); n2=zliste.get_element(2*i+1);
      stein[n1].off(); stein[n2].off(); rest=rest-2;
      lliste.add_liste(n1); lliste.add_liste(n2);
      mach_zugliste();
      k=zliste.get_size();
    }
    cnt=0; for (i=0; i<cmax; i++) if (stein[i].is_aktiv()) if (ist_frei(i)) cnt++;
    return cnt;
  }

  public void zeige_lsg()
  { restart();
    // Lösungsliste=lliste
    thread0=new Thread()
    { int i,k1,k2,k=0;
      @Override public void run()
      { zliste.leeren();
        while ((this!=null) && (k<cmax))
        { k1=lliste.get_element(k);
          k2=lliste.get_element(k+1);
          i= 6;
          while(i>0)
          { if (i%2==0)
            { blink_on(k1);
              blink_on(k2);
            }
            else
            { zliste.leeren();
            }
            i--;
            if (thread0==null) break; // Absprung aus Blinken
            try { Thread.sleep(250); }
            catch (InterruptedException e) { break; }
          }
          if (thread0==null) break; // Absprung aus Lösungsvektor
          stein[k1].off();
          stein[k2].off();
          zliste.leeren();
          k=k+2;          
        }
        restart();
      }
    };
   if (lliste.get_size()>0) thread0.start(); else thread0=null;
  }

  void blink_on(int nr)  { zliste.add_liste(nr); }

  int zeichmal(int ein)
  { int k=ein;
    aufraeumen();
    zliste.add_liste(lliste.get_element(k)); k++;
    zliste.add_liste(lliste.get_element(k)); k++;
    return k;
  }

  void aufraeumen()
  { if (zliste.get_size()>0)
    { stein[zliste.get_element(0)].off();
      stein[zliste.get_element(1)].off();
      zliste.leeren();
    }
  }

// --------------------------------------------------------------------------------------------------------------------------------
// Timer:
// --------------------------------------------------------------------------------------------------------------------------------
 void start_timer()
 { thread2 = new Thread()
   { @Override public void run() { while (thread2!=null) { if (zeit<999999) if (!gestoppt) zeit++; try { sleep(1000); }  catch (InterruptedException ex) {} } }
   };
   thread2.start();
 }

 //----------------------------------------------------------------------------------------------------------------------------------
 // Zeit, Züge und Steine laden / speichern:
 //----------------------------------------------------------------------------------------------------------------------------------

 public String[] backup_status()
 { int i,k;
   String[] gstat=new String[145];
   k=sliste.get_size();
   gstat[0]=""+zeit+","+k;
   for (i=0; i<k; i++) gstat[0]=gstat[0]+","+sliste.get_element(i);
   for (i=0; i<stein.length; i++)
   { if (stein[i].is_aktiv()) k=1; else k=0;
     gstat[i+1]=""+stein[i].get_ix()+","+stein[i].get_iy()+","+stein[i].get_iz()+","+stein[i].get_typ()+","+k;
   }
   return gstat;
 }

 public void restore_status(String[] gstat)
 { int i,k;
   String[] temp;
   temp=gstat[0].split(",");
   zeit=Integer.parseInt(temp[0]);
   k=Integer.parseInt(temp[1]);
   rest=stein.length-k;
   sliste.leeren();
   for (i=0; i<k; i++) sliste.add_liste(Integer.parseInt(temp[i+2]));
   for (i=0; i<stein.length; i++)
   { temp=gstat[i+1].split(",");
     stein[i].set_koo(Integer.parseInt(temp[0]),Integer.parseInt(temp[1]),Integer.parseInt(temp[2]));
     stein[i].set_typ(Integer.parseInt(temp[3]));
     if (Integer.parseInt(temp[4])==0) stein[i].off(); else stein[i].on();
   }
 }


}

