package svghexajongg;

/**
 *
 * @author uja
 */
public class sprite
{ int maxx=36,maxy=24,maxz=8,dx=75,dy=25,dzx=0,dzy=20,sizex=100,sizey=70,sizeyp=50;
  int id,ix,iy,iz,prio,x,y,typ,xoff,yoff;
  boolean im_spiel;

  public sprite(int nr)  { id=nr; ix=0; iy=0; typ=nr%36; im_spiel=false; }
  public void on() { im_spiel=true; }
  public void off() { im_spiel=false; }
  public boolean is_aktiv() { return im_spiel; }

  public void set_typ(int nr) { typ=nr; }
  public void set_koo(int xx,int yy,int zz) { ix=xx; iy=yy; iz=zz; calc_prio(); calc_koo(); }
  public void set_maxkoo(int xx,int yy,int zz) { maxx=xx; maxy=yy; maxz=zz; calc_koo(); calc_prio(); }
  public void set_sizes(int xx,int yy,int zx,int zy) { dx=xx; dy=yy; dzx=zx; dzy=zy; calc_koo(); }

  public int get_id() { return id; }
  public int get_typ() { return typ; }
  public int get_x() { return x; }
  public int get_y() { return y; }
  public int get_prio() { return prio; }
  public int get_iz() { return iz; }
  public int get_ix() { return ix; }
  public int get_iy() { return iy; }


  // nur Test auf Plattenstück, erst Bounding Rect, dann Polygon:
  public boolean geklickt(int xx,int yy)
  { boolean getroffen=((xx>x) && (xx<x+4*dx));
    if (getroffen) getroffen=((yy>y) && (yy<y+2*dy));
    if (getroffen) getroffen=in_poly(xx,yy);
    return getroffen;
  }

  void calc_prio() { prio=iy+iz*maxx*maxy;  }
  void calc_koo()  { xoff=maxz*dzx; yoff=maxz*dzy; x=xoff+ix*dx-iz*dzx; y=yoff+iy*dy-iz*dzy; }

  boolean in_poly(int xx,int yy)
  { int i,k,pmax=6;
      int[] polyx={ x,    x+dx,x+3*dx,x+4*dx, x+3*dx, x+dx,};
      int[] polyy={ y+dy, y,   y,     y+dy,   y+2*dy, y+2*dy };
      int[] polyx1=new int[pmax];
      int[] polyy1=new int[pmax];
      // Koordinatentransformation, so verschieben dass Hotspot->0,0:
      for (i=0; i<pmax; i++)
      { polyx1[i]=polyx[i]-xx;
        polyy1[i]=polyy[i]-yy;
      }
      // aufaddieren der Winkel:
      double sum=0.0;
      for (i=0; i<pmax; i++)
      { k=(i+1)%pmax;
        sum=sum+Math.atan2(polyy1[k]*polyx1[i]-polyx1[k]*polyy1[i],polyx1[k]*polyx1[i]+polyy1[k]*polyy1[i]);
      }
      return (Math.abs(sum)>0.000001);
    }

}
